local start_timestamp = tonumber(io.read('l'))
local buses = {}

-- 'x' is translated to -1
io.read('l'):gsub('[^,]*', function (bus) table.insert(buses, tonumber(bus) or -1) end)

-- Copy and sort the buses, ignoring 'x' for part 1
local sorted_buses = {}
for _, bus in ipairs(buses) do
    if bus > 0 then
        table.insert(sorted_buses, bus)
    end
end
table.sort(sorted_buses)

local function find_bus(timestamp)
    for _, bus in ipairs(sorted_buses) do
        if bus > 0 and timestamp % bus == 0 then
            return bus
        end
    end
end

local timestamp, bus_id = start_timestamp - 1, nil
repeat
    timestamp = timestamp + 1
    bus_id = find_bus(timestamp)
until bus_id
print(bus_id * (timestamp - start_timestamp))

-- Chinese remainder theorem. I will never ever understand congruences.
local n = 1
for _, v in ipairs(sorted_buses) do
    n = n * v
end

local function inverse(antibus, bus)
    for i = 1, bus - 1 do
        if (antibus % bus * i) % bus == 1 then
            return i
        end
    end
    return 1
end

timestamp = 0
for i, bus in ipairs(buses) do
    if bus > 0 then
        local antibus = n / bus
        timestamp = timestamp + (bus - i + 1) * antibus * inverse(antibus, bus)
    end
end
timestamp = timestamp % n

--[[
    There is a bug in the above code and I can't fix it but it seems that
    this gets me really close to the real answer, so I'll just go back to the
    bruteforce way from here.
]]
local function check_part2(timestamp)
    for i, bus in ipairs(buses) do
        if bus > 0 and (timestamp - 1 + i) % bus ~= 0 then
            return
        end
    end
    return timestamp
end

while not check_part2(timestamp) do
    timestamp = timestamp + 1
end

print(string.format("%d", timestamp))
