#!/usr/bin/env perl
use strict;
use warnings;

sub parse_rule {
    my ($rule) = @_;
    $rule =~ s/"//g;
    $rule =~ s/(\d+)(?![\d:])/(?&rule$1)/g;
    $rule =~ s/^(\d+):\s*(.*)$/(?<rule$1>$2)/;
    return $rule;
}

my $rules = "";

while (<>) {
    chomp;
    if ($_ eq "") {
        last;
    }
    $rules .= parse_rule($_) . "\n";
}

my $regexp = "(?(DEFINE)" . $rules . ")^(?&rule0)\$";

my $newrule8 = parse_rule('8: 42 | 42 8');
my $newrule11 = parse_rule('11: 42 31 | 42 11 31');
my $regexp2 = $regexp;
$regexp2 =~ s/\(\?<rule8>.*\)/$newrule8/;
$regexp2 =~ s/\(\?<rule11>.*\)/$newrule11/;

$regexp =~ s/\s*//g;
$regexp2 =~ s/\s*//g;

my $part1 = 0, my $part2 = 0;
while (<>) {
    $part1 += ($_ =~ $regexp);
    $part2 += ($_ =~ $regexp2);
}
print $part1, "\n", $part2, "\n";
