#!/usr/bin/env lua

local numbers = {}

for line in io.lines() do
    table.insert(numbers, tonumber(line))
end


local function part1()
    local count = 0
    for i = 2, #numbers do
        if numbers[i-1] < numbers[i] then
            count = count + 1
        end
    end
    return count
end

local function part2()
    local count = 0
    for i = 4, #numbers do
        local previous_sum = numbers[i-3] + numbers[i-2] + numbers[i-1]
        local current_sum = numbers[i-2] + numbers[i-1] + numbers[i]
        if previous_sum < current_sum then
            count = count + 1
        end
    end
    return count
end

print(part1())
print(part2())
